
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;


@SuppressWarnings("serial")
public class Mediator_MainFrame extends JFrame implements  ActionListener{

    private JDesktopPane desktopPane = new JDesktopPane();
    private int nr=0;
      
    public Mediator_MainFrame() {
        this.setSize(900, 600);
        setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
        setGUI();
        createMediator();
       // this.setVisible(true);
    }
    
    private void setGUI() {
        setLayout(new BorderLayout() );
        add(desktopPane, BorderLayout.CENTER);
        setToolBars();    
        setMenus();        
    }
    
  private void setMenus() {
    JMenuBar menuBar1= new JMenuBar();

    JMenu mainFile = new JMenu("File");;
    JMenuItem mnNew = new JMenuItem("New Client");
    mnNew.addActionListener(this);
    mnNew.setActionCommand("NewClient");
    mnNew.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK));
    mainFile.add(mnNew);
    mainFile.addSeparator();
    
    JMenuItem mnClose = new JMenuItem("Close");
    mnClose.addActionListener(this);
    mnClose.setActionCommand("Close");
    mainFile.add(mnClose);
    menuBar1.add(mainFile);
    this.setJMenuBar(menuBar1);
    
    JMenu mainWindows = new JMenu("Fenster");     // HauptMen
    JMenuItem mnPrevWindows = new JMenuItem("Vorheriges Fenster");
    JMenuItem mnNextWindows = new JMenuItem("Nchstes Fenster");
    JMenuItem mnCascade = new JMenuItem("Kaskade");
    mnCascade.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_F6, 0));

    JMenuItem mnTile = new JMenuItem("Aufteilen");
    mnTile.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_F7, 0));
    JMenuItem mnTileVertical = new JMenuItem("Aufteilen Vertikal");
    mnTileVertical.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_F8, 0));

    JMenuItem mnTileHorizontal = new JMenuItem("Aufteilen Horizontal");
    mnTileHorizontal.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_F9, 0));

      // Event definieren
    mnPrevWindows.addActionListener(this);
    mnNextWindows.addActionListener(this);
    mnCascade.addActionListener(this);
    mnTile.addActionListener(this);
    mnTileVertical.addActionListener(this);
    mnTileHorizontal.addActionListener(this);

    mnPrevWindows.setActionCommand("PrevWindows");
    mnNextWindows.setActionCommand("NextWindows");
    mnCascade.setActionCommand("Cascade");
    mnTile.setActionCommand("Tile");
    mnTileVertical.setActionCommand("TileVertical");
    mnTileHorizontal.setActionCommand("TileHorizontal");
      // MenEintrge definieren

    mainWindows.add(mnPrevWindows);
    mainWindows.add(mnNextWindows);
    mainWindows.addSeparator();
    mainWindows.add(mnCascade);
    mainWindows.add(mnTile);
    mainWindows.add(mnTileVertical);
    mainWindows.add(mnTileHorizontal);
    menuBar1.add(mainWindows);    

    for (int i = 0; i < menuBar1.getComponentCount(); i++) {
      JMenu main = (JMenu) menuBar1.getComponent(i);
      main.setFont(new Font("Arial", Font.BOLD, 18));
      for (int j = 0; j < main.getItemCount(); j++) {
        Component c = main.getItem(j);
        if (c instanceof JMenuItem) {
          JMenuItem mn = (JMenuItem) c;
          mn.setFont(new Font("Arial", Font.BOLD, 18));
        }
      }
    }
  } // setMenues
    
  private void setToolBars() {
    JToolBar toolBar = new JToolBar();

    JButton bnNewClient = new JButton("New Client");
    bnNewClient.setFont(new Font("Arial", Font.BOLD, 18));
    toolBar.add(bnNewClient);
    bnNewClient.addActionListener(this);
    bnNewClient.setActionCommand("NewClient");

    this.getContentPane().add(toolBar, BorderLayout.NORTH);
  } // setToolBars
    
  private void createMediator() {
	  MediatorInternalFrame frame = new MediatorInternalFrame();
      int pos = desktopPane.getAllFrames().length+1;
      frame.setBounds(pos*10, pos*10, 450, 250);
      desktopPane.add(frame);
      desktopPane.moveToFront(frame);

  }
   
    @Override
    public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();

        if (cmd.equals("NewClient") ) {
             ClientInternalFrame frame = new ClientInternalFrame("User_"+(++nr));
             int pos = desktopPane.getAllFrames().length+1;
             frame.setBounds(pos*10, pos*10, 450, 250);
             desktopPane.add(frame);
             desktopPane.moveToFront(frame);
         }
        
        if (cmd.equals("PrevWindows") ) {
            WindowLayout.mnPrevWindows(desktopPane);
         }
         if (cmd.equals("NextWindows") ) {
           WindowLayout.mnNextWindows(desktopPane);
         }


         if (cmd.equals("Cascade") ) {
           WindowLayout.mnCascade(desktopPane);
        }
         if (cmd.equals("Tile") ) {
            WindowLayout.mnTile(desktopPane);
        }
         if (cmd.equals("TileVertical") ) {
           WindowLayout.mnTileVertical(desktopPane);    
        }
         if (cmd.equals("TileHorizontal") ) {
           WindowLayout.mnTileHorizontal(desktopPane);
        }
        
    }  // actionPerformed
    
    public static void main(String[] args) {
        Mediator_MainFrame frame = new Mediator_MainFrame();
        frame.setVisible(true);
    }

    
}
